const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const translation_keys = sequelize.define(
    'translation_keys',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

key_name: {
        type: DataTypes.TEXT,
      
      

      },

namespace: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  translation_keys.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

























    db.translation_keys.hasMany(db.translations, {
      as: 'translations_translation_key',
      foreignKey: {
          name: 'translation_keyId',
      },
      constraints: false,
    });



//end loop



    db.translation_keys.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.translation_keys.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.translation_keys.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return translation_keys;
};


